unit globals;

interface

uses Graphics, fpc4delphi;

const AboutTitle = 'Over dit spel';
      ProductName = 'Conway''s Game of Life';
     {$IFNDEF HUGE_WORLD}
      Version = 'Versie 1.0.0.4';
      {$ELSE}
      Version = 'Versie 1.0.0.4 XL';
      {$ENDIF}
      CopyRight = 'Auteur: Flying Sheep Inc. & B. Broersma';
      ProductURL = 'http://home.tiscali.nl/~knmg0017/';
      LicenceCaption = 'Deze implementatie valt onder de volgende licentievoorwaarden:';
      LicenseName = 'Mozilla Public License Versie 1.1';
      LicenseUrl = 'http://www.mozilla.org/MPL/MPL-1.1.html';
      ProductComment = 'De regels van het spel zijn gemaakt'^m'door de Britse wiskundige John Conway.';

      
const clGrid = clYellow;
      clDead = $00FFc8c8;//clWhite;
      clLife = clBlack;

const {$IFNDEF HUGE_WORLD}
      MinLifeX = 5;
      MinLifeY = 5;
      MaxLifeX = 256;//120;
      MaxLifeY = 192;//80;
      MinCellX = 4;
      MinCellY = 4;
      MaxCellX = 50;
      MaxCellY = 50;
      SmallJump = 1;
      LargeJump = 5;
      {$ELSE}
      MinLifeX = 320;
      MinLifeY = 240;
      MaxLifeX = 1280;
      MaxLifeY = 1024; // --> 52 428 800 bytes voor TLifeGeneration
      MinCellX = 1;
      MinCellY = 1;
      MaxCellX = 2;
      MaxCellY = 2;
      SmallJump = 1;
      LargeJump = 10;
      {$ENDIF}

(*
MinCellX = 2
MinCellY = 2
MaxLifeX = 2048 div 3 - 10  {=672}
MaxLifeY = 1536 div 3 - 10 {=512}
Dit geeft ruimte op een beeldscherm van 2048*1536 voor 337344 cellen elk 2 px groot
de rest van de ruimte is nodig voor het grid.
SizeOf(TLifeGeneration) is dan 13 4936 760 bytes.
Het programma eet dan ca 20 MB geheugen op mijn WinMe systeem

In de configuratie 256*192 is SizeOf(TLifeGeneraion) 1 966 080
en neemt het programma ongeveer 7.5 MB geheugen in beslag
Bij een celgroote van 4 is dat levert dat een bord op van ca 1280 * 960 pixels
*)

const wrNone = 0;
      wrHorizontal = $01;
      wrVertical = $02;
      wrBoth = wrHorizontal or wrVertical;

const TimerIntervalFastest = 1;
      TimerIntervalFaster = 50;
      TimerIntervalAverage = 100;
      TimerIntervalSlower = 250;
      TimerIntervalSlowest = 1000;

const AppName = 'Flying Sheep Inc'+PathDelim+'Game of Life';
      scDimension = 'Afmetingen';
        idLifeX = 'HorCells';
        idLifeY = 'VertCells';
        idCellX = 'HorCellGrootte';
        idCellY = 'VertCellGrootte';
      scOptions = 'Opties';
        idTimerInterval = 'TimerInterval';
        idWrap = 'Wrapping';

var AppConfigDir, ConfigFilename: String;


const RulesFileName = 'DeRegelsVanHetSpel.txt';
      PlayFileName = 'HoeTeSpelen.txt';


function GetAppName: String; //voor GetAppConfigDir

implementation


function GetAppName: String;
begin
  Result := AppName;
end;


Initialization
  OnGetApplicationName := GetAppName;
  AppConfigDir := GetAppConfigDir(False);
  {$IFNDEF HUGE_WORLD}
  ConfigFileName := IncludeTrailingPathDelimiter(AppConfigDir) + 'life.ini';
  {$ELSE}
  ConfigFileName := IncludeTrailingPathDelimiter(AppConfigDir) + 'lifeXL.ini';
  {$ENDIF}
end.
