unit ulife;


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, Menus, StdCtrls, Errors, ExtMsgDlg, Globals, fpc4delphi;




const Dead = 0;
      Alive = 1;
      LifeChars = ['o','O','0','+','*'];
      CommentChars = ['#','!'];
      LifeChar = 'O';
      DeadChar = '.';

const OpenDlgFilter = 'life-bestanden (*.life;*.lif)|*.life;*.lif|cell-bestanden (*.cells)|*.cells|alle bestanden (*.*)|*.*';
      SaveDlgFilter = 'life-bestanden (*.life;*.lif)|*.life;*.lif|alle bestanden (*.*)|*.*';
      LifeExt = 'life';
      msgErrorFileOpen = 'Fout bij openen van bestand:'^m'%s';
      msgErrorFileSave = 'Fout bij opslaan van bestand:'^m'%s'^m^m'%s';
      msgErrorsaveOptions = 'Helaas is er wat misgegaan bij het opslaan '+
                            'van de instellingen in het bestand:'^m^m'%s'^m^m'%s';
      msgErrorSaveOptionsDir = 'Helaas is er wat misgegaan bij het opslaan van de instellingen:'^m^m+
                               'De map "%s"'^m^m'kon niet worden aangemaakt.'^m^m'%s';
      msgErrorInternalBitmapFormat = 'Er is iets misgegaan bij het aanmaken van een interne bitmap.'^m+
                                     'Uw systeem ondersteunt mogelijk geen 24-bits bitmaps'^m^m+
                                     'Dit kan te maken hebben met de instellingen van uw videokaart.'^m+
                                     'Voor een juiste werking van het programma wordt een instelling'^m+
                                     'van uw beeldscherm op minimaal "hoge kleuren" (16-bit) aanbevolen.'^m^m+
                                     'Mocht u het probleem niet kunnen oplossen, meldt het dan via de website:'^m^m+
                                     ProductUrl;
      msgEmptying = 'Bezig met legen en tekenen van %d x %d celllen...';
      msgDrawing = 'Bezig met tekenen van %d x %d celllen...';
      msgProcessing = 'Bezig %d x %d  cellen te verwerken...';

type TLifeStatus = Integer;
     PCell = ^TCell;
     TCell = Record
               Status, PrevStatus: TLifeStatus;
               TopLeft, TopMid, TopRight,
               Left, Right,
               BottomLeft, BottomMid, BottomRight: PCell;
             end;
     TLifeGeneration = Array[0..MaxLifeX-1,0..MaxLifeY-1] of TCell;


     TWorld = TImage;


type
  TLifeForm = class(TForm)
    MainMenu1: TMainMenu;
    MenuBestand: TMenuItem;
      MenuNewGame: TMenuItem;
      N1: TMenuItem;
      MenuSaveGame: TMenuItem;
      MenuOpenGame: TMenuItem;
      N2: TMenuItem;
      MenuCloseGame: TMenuItem;
    MenuSpel: TMenuItem;
      MenuStartGame: TMenuItem;
      MenuOneStep: TMenuItem;
      N5: TMenuItem;
      MenuMoveLeft : TMenuItem;
      MenuMoveRight: TMenuItem;
      MenuMoveUp   : TMenuItem;
      MenuMoveDown : TMenuItem;
      N4: TMenuItem;
      MenuMoveLeftLarge: TMenuItem;
      MenuMoveRightLarge: TMenuItem;
      MenuMoveUpLarge: TMenuItem;
      MenuMoveDownLarge: TMenuItem;
      N6: TMenuItem;
      MenuFlipHorizontal: TMenuItem;
      MenuFlipVertical: TMenuItem;
      N7: TMenuItem;
      MenuRotateLeft: TMenuItem;
      MenuRotateRight: TMenuItem;
      MenuRotate180: TMenuItem;
    MenuOptions: TMenuItem;
    MenuHelp: TMenuItem;
      MenuInstructions: TMenuItem;
      N3: TMenuItem;
      MenuAbout: TMenuItem;

    StatusBar: TStatusBar;
    WorldTimer: TTimer;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure MenuClick(Sender: TObject);
    procedure MenuNewGameClick(Sender: TObject);
    procedure MenuSaveGameClick(Sender: TObject);
    procedure MenuOpenGameClick(Sender: TObject);
    procedure MenuCloseGameClick(Sender: TObject);
    procedure MenuStartGameClick(Sender: TObject);
    procedure MenuOneStepClick(Sender: TObject);
    procedure MenuMoveLeftClick(Sender: TObject);
    procedure MenuMoveRightClick(Sender: TObject);
    procedure MenuMoveUpClick(Sender: TObject);
    procedure MenuMoveDownClick(Sender: TObject);
    procedure MenuMoveLeftLargeClick(Sender: TObject);
    procedure MenuMoveRightLargeClick(Sender: TObject);
    procedure MenuMoveUpLargeClick(Sender: TObject);
    procedure MenuMoveDownLargeClick(Sender: TObject);
    procedure MenuFlipHorizontalClick(Sender: TObject);
    procedure MenuFlipVerticalClick(Sender: TObject);
    procedure MenuRotateLeftClick(Sender: TObject);
    procedure MenuRotateRightClick(Sender: TObject);
    procedure MenuRotate180Click(Sender: TObject);
    procedure MenuOptionsClick(Sender: TObject);
    procedure MenuAboutClick(Sender: TObject);
    procedure MenuInstructionsClick(Sender: TObject);

    procedure WorldMouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure WorldTimerTimer(Sender: TObject);
    procedure StatusBarResize(Sender: TObject);

    function LoadOptions: Boolean;
    function SaveOptions: Boolean;
    procedure DoOptionsDlg;

    procedure InitLife;
    procedure DrawBackGround;
    procedure DrawGridLines;
    procedure DrawEmptyWorld;
    procedure CopyChalkBoardToTheWorld;
    procedure MakeConnections(const UpdateBordersOnly: Boolean);
    procedure ResizeTheWorld(const NewLifeX, NewLifeY, NewCellX, NewcellY: Integer);
    procedure DrawCell(X,Y: Integer; AColor: TColor; Direct: Boolean);
    procedure DrawGeneration(const ForceAllCells: Boolean);
    procedure BackupGeneration;
    function Neighbours(const X,Y: Integer): Integer;
    procedure CalcNextGeneration;
    procedure DoNextGeneration;
    procedure RunTheWorld;
    procedure UpdateStatusBar;
    procedure UpdateMenu;

    procedure KillAllCells;
    procedure TrimLifeLines(SL: TStringList);
    procedure NewGame;
    procedure OpenGame;
    procedure SaveGame;

    procedure MoveLeft(const ADistance: Integer);
    procedure MoveRight(const ADistance: Integer);
    procedure MoveUp(const ADistance: Integer);
    procedure MoveDown(const ADistance: Integer);
    procedure FlipHorizontal;
    procedure FlipVertical;
    procedure RotateLeft;
    procedure RotateRight;
    procedure Rotate180;

    procedure GameInstructions;
    procedure AboutGame;

  private
    { private declarations }
    Generation: TLifeGeneration;
    fGenerationCount: DWord;
    fCellX, fCellY, fLifeX, fLifeY: Integer;
    fNilCell: TCell;
    fWrapStyle: Integer;
    fTimerRequestHandled, fNothingHasChanged, fRunning,
    fOptionsChanged: Boolean;
    World: TWorld;
    ChalkBoard: TBitmap;
    procedure SetWrapStyle(Value: Integer);
  public
    { Public declarations }
    property WrapStyle: Integer Read fWrapStyle Write SetWrapStyle;
  end;

var
  LifeForm: TLifeForm;

implementation

{$R *.DFM}

uses uoptionsdlg, uhelp, IniFiles, FileCtrl, Misc, About;




{********************************** Form Events ********************************}


procedure TLifeForm.FormCreate(Sender: TObject);
begin
  Application.Title := 'Conway''s Game of Life';
  fGenerationCount := 0;
  //Default waardes, als configuratiebestand ontbreekt;
  {$IFNDEF HUGE_WORLD}
  fCellX := 15;
  fCellY := 15;
  fLifeX := 40;
  fLifeY := 40;
  {$ELSE}
  fCellX := 1;
  fCellY := 1;
  fLifeX := MinLifeX;
  fLifeY := MinLifeY;
  {$ENDIF}
  World := nil;
  ChalkBoard := nil;
  fNilCell.Status := Dead;
  fNilCell.PrevStatus := Dead; //Nodig voor MoveLeft etc.
  fWrapStyle := wrHorizontal;
  WorldTimer.Interval := TimerIntervalAverage;
  MenuMoveLeftLarge.Caption := Format(MenuMoveLeftLarge.Caption,[LargeJump]);
  MenuMoveRightLarge.Caption := Format(MenuMoveRightLarge.Caption,[LargeJump]);
  MenuMoveUpLarge.Caption := Format(MenuMoveUpLarge.Caption,[LargeJump]);
  MenuMoveDownLarge.Caption := Format(MenuMoveDownLarge.Caption,[LargeJump]);

  //Dit moet _voor_ MakeConnections
  fOptionsChanged := not LoadOptions;
  //Als er iets misgaat, of het bestand bestaat niet, sla opties dan weer op bij afsluiten

//@@
//fcellx := 1;
//fcelly := 1;
//flifex := 300;
//flifey := 300;

  InitLife;
  MakeConnections(False);
  OpenDialog.Filter := OpenDlgFilter;
  SaveDialog.Filter := SaveDlgFilter;
  SaveDialog.DefaultExt := LifeExt;


end;

procedure TLifeForm.FormShow(Sender: TObject);
begin
//  World.Align := alClient;
  DrawEmptyWorld;
  UpdateStatusBar;
  fTimerRequestHandled := True;
end;

procedure TLifeForm.FormDestroy(Sender: TObject);
begin
  if Assigned(World) then World.Free;
  if Assigned(ChalkBoard) then ChalkBoard.Free;
end;

procedure TLifeForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  WorldTimer.Enabled := False;
  if fOptionsChanged then SaveOptions;
end;


{********************************** Menu Events ********************************}

procedure TLifeForm.MenuClick(Sender: TObject);
begin
  UpdateMenu;
end;

procedure TLifeForm.MenuNewGameClick(Sender: TObject);
begin
  NewGame;
end;

procedure TLifeForm.MenuSaveGameClick(Sender: TObject);
begin
  SaveGame;
end;

procedure TLifeForm.MenuOpenGameClick(Sender: TObject);
begin
  OpenGame;
end;

procedure TLifeForm.MenuCloseGameClick(Sender: TObject);
begin
  Close;
end;

procedure TLifeForm.MenuStartGameClick(Sender: TObject);
begin
  fRunning := not fRunning;
  if fRunning and (WorldTimer.Interval > 250) then DoNextgeneration;
  WorldTimer.Enabled := fRunning;
end;

procedure TLifeForm.MenuOneStepClick(Sender: TObject);
begin
  if not fRunning then DoNextGeneration;
end;

procedure TLifeForm.MenuMoveLeftClick(Sender: TObject);
begin
  if fRunning then exit;
  MoveLeft(SmallJump);
end;

procedure TLifeForm.MenuMoveRightClick(Sender: TObject);
begin
  if fRunning then exit;
  MoveRight(SmallJump);
end;

procedure TLifeForm.MenuMoveUpClick(Sender: TObject);
begin
  if fRunning then exit;
  MoveUp(SmallJump);
end;

procedure TLifeForm.MenuMoveDownClick(Sender: TObject);
begin
  if fRunning then exit;
  MoveDown(SmallJump);
end;

procedure TLifeForm.MenuMoveLeftLargeClick(Sender: TObject);
begin
  if fRunning then exit;
  MoveLeft(LargeJump);
end;

procedure TLifeForm.MenuMoveRightLargeClick(Sender: TObject);
begin
  if fRunning then exit;
  MoveRight(LargeJump);
end;

procedure TLifeForm.MenuMoveUpLargeClick(Sender: TObject);
begin
  if fRunning then exit;
  MoveUp(LargeJump);
end;

procedure TLifeForm.MenuMoveDownLargeClick(Sender: TObject);
begin
  if fRunning then exit;
  MoveDown(LargeJump);
end;

procedure TLifeForm.MenuFlipHorizontalClick(Sender: TObject);
begin
  if fRunning then exit;
  FlipHorizontal;
end;

procedure TLifeForm.MenuFlipVerticalClick(Sender: TObject);
begin
  if fRunning then exit;
  FlipVertical;
end;

procedure TLifeForm.MenuRotateLeftClick(Sender: TObject);
begin
  if fRunning then exit;
  RotateLeft;
end;

procedure TLifeForm.MenuRotateRightClick(Sender: TObject);
begin
  if fRunning then exit;
  RotateRight;
end;

procedure TLifeForm.MenuRotate180Click(Sender: TObject);
begin
  if fRunning then exit;
  Rotate180;
end;

procedure TLifeForm.MenuOptionsClick(Sender: TObject);
begin
  DoOptionsDlg;
end;

procedure TLifeForm.MenuInstructionsClick(Sender: TObject);
begin
  GameInstructions;
end;

procedure TLifeForm.MenuAboutClick(Sender: TObject);
begin
  if fRunning then exit;
  AboutGame;
end;


{********************************** FormControls Events ********************************}

procedure TLifeForm.WorldMouseDown(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var TheStatus: Integer;
    WorldX, WorldY: Integer;
    StatString, PrevStatString: String;
begin
  if fRunning then Exit;
  WorldX := X div fCellX;
  WorldY := Y div fCellY;
  {$IFNDEF HUGE_WORLD}
  if (X = 1) or (X = World.Width - 1) or (Y = 0) or (Y = World.Height - 1) or
    ((X mod fCellX) = 0) or ((Y mod fCellY) = 0) then
  begin
    //We zitten op een Gridlijn
    exit;
  end;
  {$ELSE}
//  WorldX := X;
//  WorldY := Y;
  {$ENDIF}
  if (WorldX > fLifeX) or (WorldY > fLifeY) then Exit;
  TheStatus := Generation[WorldX,WorldY].Status;
  if (ssShift in Shift) then
  begin
    if (TheStatus = Dead) then StatString := 'Dood' else StatString := 'Levend';
    if (Generation[WorldX,WorldY].PrevStatus = Dead) then PrevStatString := 'Dood' else PrevStatString := 'Levend';
    StatusBar.Panels[1].Text := Format('Cel[%d,%d]: Buren = %d, Status = %s, Vorige status = %s',[WorldX,WorldY,Neighbours(WorldX,WorldY),StatString,PrevStatString]);
  end
  else
  begin
    if TheStatus = Dead then
    begin
      Generation[WorldX,WorldY].Status := Alive;
      Generation[WorldX,WorldY].PrevStatus := Alive;
      Drawcell(WorldX,WorldY,clLife,True);
      StatusBar.Panels[1].Text := Format('Cel[%d,%d]: Dood --> Levend',[WorldX,WorldY]);
    end
    else if TheStatus = ALive then
    begin
      Generation[WorldX,WorldY].Status := Dead;
      Generation[WorldX,WorldY].PrevStatus := Dead;
      Drawcell(WorldX,WorldY,clDead,True);
      StatusBar.Panels[1].Text := Format('Cel[%d,%d]: Levend --> Dood',[WorldX,WorldY]);
    end;
//    StatusBar.Panels[1].Text := '';
  end;
end;

procedure TLifeForm.WorldTimerTimer(Sender: TObject);
begin
  RunTheWorld;
end;

procedure TLifeForm.StatusBarResize(Sender: TObject);
begin
  StatusBar.Panels[0].Width := StatusBar.Canvas.TextWidth(Format('Generatie: +%d',[MaxLongInt]));
end;



{********************************** Form Methods ********************************}




function TLifeForm.LoadOptions: Boolean;
var IniFile: TIniFile;
    TI: Integer;
begin
  Result := False;
  IniFile := TIniFile.Create(ConfigFileName);
  try
    fLifeX := LimitTo(IniFile.ReadInteger(scDimension, idLifeX, fLifeX), MinLifeX, MaxLifeX);
    fLifeY := LimitTo(IniFile.ReadInteger(scDimension, idLifeY, fLifeY), MinLifeY, MaxLifeY);
    fCellX := LimitTo(IniFile.ReadInteger(scDimension, idCellX, fCellX), MinCellX, MaxCellX);
    fCellY := LimitTo(IniFile.ReadInteger(scDimension, idCellY, fCellY), MinCellY, MaxCellY);
    fWrapStyle := LimitTo(IniFile.ReadInteger(scOptions, idWrap, fWrapStyle), wrNone, wrBoth);
    TI := LimitTo(IniFile.ReadInteger(scOptions, idTimerInterval, WorldTimer.Interval), TimerIntervalFastest, TimerIntervalSlowest);
    case TI of
      TimerIntervalFastest, TimerIntervalFaster,
      TimerIntervalAverage,
      TimerIntervalSlower, TimerIntervalSlowest: WorldTimer.Interval := TI;
    end;
  finally
    IniFile.Free;
  end;
  Result := true;
end;

function TLifeForm.SaveOptions: Boolean;
var IniFile: TIniFile;
begin
  Result := False;
  if not DirectoryExists(AppConfigDir) then
  begin
    if not CreateMultiLevelDir(AppConfigDir) then
    begin
      MessageDlg(Format(msgErrorSaveOptionsDir,[AppConfigDir,NlErrorMsg(GetLastError)]), mtError,[mbOk],0);
      exit;
    end;
  end;
  IniFile := TIniFile.Create(ConfigFileName);
  try
    try
      IniFile.WriteInteger(scDimension, idLifeX, fLifeX);
      IniFile.WriteInteger(scDimension, idLifeY, fLifeY);
      IniFile.WriteInteger(scDimension, idCellX, fCellX);
      IniFile.WriteInteger(scDimension, idCellY, fCellY);
      IniFile.WriteInteger(scOptions, idWrap, fWrapStyle);
      IniFile.WriteInteger(scOptions, idTimerInterval, WorldTimer.Interval);
    except
      MessageDlg(Format(msgErrorSaveOptions,[ConfigFileName,NlErrorMsg(GetLastError)]), mtError,[mbOk],0);
    end;
  finally
    IniFile.Free;
  end;
  Result := true;
end;


procedure TLifeForm.DoOptionsDlg;
begin
  fRunning := False;
  WorldTimer.Enabled := False;
  UpdateMenu;
  OptionsDlg.optLifeX := fLifeX;
  OptionsDlg.optLifeY := fLifeY;
  OptionsDlg.optCellX := fCellX;
  OptionsDlg.optCellY := fCellY;
  OptionsDlg.optWrapStyle := fWrapStyle;
  OptionsDlg.optTimerInterval := WorldTimer.Interval;
  if OptionsDlg.ShowModal = mrOk then
  begin
    fOptionsChanged := True;
    if (OptionsDlg.optLifeX <> fLifeX) or
       (OptionsDlg.optLifeY <> fLifeY) or
       (OptionsDlg.optCellX <> fCellX) or
       (OptionsDlg.optCellY <> fCellY) then
      ResizeTheWorld(OptionsDlg.optLifeX,OptionsDlg.optLifeY,OptionsDlg.optCellX,OptionsDlg.optCellY);
    if OptionsDlg.optWrapStyle <> fWrapStyle then SetWrapStyle(OptionsDlg.optWrapStyle);
    if OptionsDlg.optTimerInterval <> WorldTimer.Interval then WorldTimer.Interval := OptionsDlg.optTimerInterval;
  end;
end;


procedure TLifeForm.InitLife;
begin
  FillChar(Generation, SizeOf(TLifeGeneration), 0);
end;

procedure TLifeForm.DrawBackGround;
begin
(*
showmessage(format('fLifex = %d'^m'fLifeY = %d'^m+
                   'WW = %d'^m'WCW = %d'^m+
                   'WH = %d'^m'WCH = %d'^m+
                   'FW = %d'^m'FCW = %d'^m+
                   'FH = %d'^m'FCH = %d'^m+
                   'CR.Left = %d'^m+
                   'CR.Top = %d'^m+
                   'CR.Right = %d'^m+
                   'CR.Bottom = %d',
                   [flifex,flifey,world.width,world.clientwidth,
                   world.height,world.clientheight,
                   width,clientwidth,height,clientheight,
                   world.canvas.cliprect.left,
                   world.canvas.cliprect.top,
                   world.canvas.cliprect.right,
                   world.canvas.cliprect.bottom]));

*)

  //World.Canvas.Pen.Color := clGrid;
  //World.Canvas.Brush.Color := clDead;
  //World.Canvas.FillRect(Rect(0,0,World.ClientWidth,World.ClientHeight));

  //Eerst painten op bitmap en dan kopiren is sneller dan rechtstreeks painten
  //Bij een veld van 256*256 in HUGE_WORLD mode gaat de tijd van 6300 --> 2925 ms
  //als een volledig veld getekend moet worden
  ChalkBoard.Canvas.Pen.Color := clGrid;
  ChalkBoard.Canvas.Brush.Color := clDead;
  ChalkBoard.Canvas.FillRect(Rect(0,0,World.ClientWidth,World.ClientHeight));
end;

procedure TLifeForm.DrawGridLines;
var X, Y: Integer;
begin
(*
  World.Canvas.Pen.Color := clGrid;
  World.Canvas.Brush.Color := clDead;
  for x := 0 to (World.{Canvas.}Width) div fCellX do
  begin
    World.Canvas.MoveTo(x*fCellX,0);
    World.Canvas.LineTo(x*fCellX,World.{Canvas.}Height);
  end;
  for y := 0 to (height) div fCellY do
  begin
    World.Canvas.MoveTo(0,y*fCellY);
    World.Canvas.LineTo(World.{Canvas.}Width,y*fCellY);
  end;
  {Draw a rectangle}
  World.Canvas.MoveTo(1,0);
  World.Canvas.LineTo(World.{Canvas.}Width-1,0);
  World.Canvas.LineTo(World.{Canvas.}Width-1,World.{Canvas.}Height-1);
  World.Canvas.LineTo(0,World.{Canvas.}Height-1);
  World.Canvas.LineTo(0,0);
*)
  ChalkBoard.Canvas.Pen.Color := clGrid;
  ChalkBoard.Canvas.Brush.Color := clDead;
  for x := 0 to (ChalkBoard.{Canvas.}Width) div fCellX do
  begin
    ChalkBoard.Canvas.MoveTo(x*fCellX,0);
    ChalkBoard.Canvas.LineTo(x*fCellX,ChalkBoard.{Canvas.}Height);
  end;
  for y := 0 to (height) div fCellY do
  begin
    ChalkBoard.Canvas.MoveTo(0,y*fCellY);
    ChalkBoard.Canvas.LineTo(ChalkBoard.{Canvas.}Width,y*fCellY);
  end;
  {Draw a rectangle}
  ChalkBoard.Canvas.MoveTo(1,0);
  ChalkBoard.Canvas.LineTo(ChalkBoard.{Canvas.}Width-1,0);
  ChalkBoard.Canvas.LineTo(ChalkBoard.{Canvas.}Width-1,ChalkBoard.{Canvas.}Height-1);
  ChalkBoard.Canvas.LineTo(0,ChalkBoard.{Canvas.}Height-1);
  ChalkBoard.Canvas.LineTo(0,0);

end;


procedure TLifeForm.DrawEmptyWorld;
var WX, WY, WL, WT: Integer;
begin
  //Door World telkens op te ruimen en opneuw te creeren wordt voorkomen
  //dat World.Canvas.ClipRect vast blijft staan op de waardes van de eerste keer
  //dat het canvas wordt gemaakt. Helaas is ClipRect een ReadOnly property.
  //Bij  het wijzigen van de grootte van World vereandert ClipRect niet mee,
  //zodat er buiten de oude grenzen niet getekend kan worden.
  if Assigned(World) then
  begin
    World.Free;
    World := nil;
  end;
  World := TWorld.Create(Self);
  World.Parent := Self;
//if not (world.Picture.bitmap = nil) then //showmessage('Bitmap assigned') else showmessage('No Bitmap assigned');

  World.OnMouseDown := WorldMouseDown;
  World.Top := 0;
  World.Left := 0;

//  if Assigned(ChalkBoard) then
//  begin
//    ChalkBoard.Free;
//    ChalkBoard := nil;
//  end;
  if not Assigned(ChalkBoard) then
  begin
    ChalkBoard := TBitmap.Create;
    ChalkBoard.PixelFormat := pf24bit;
    if ChalkBoard.PixelFormat <> pf24bit then
    begin
      //Tekenroutines gaan uit van en 24-bit bitmap
      //als deze niet gemaakt kan worden moeten we het programma hier afsluiten,
      //anders krijgen we GPF's bij het tekenen.
      CenterDialogsOverMainForm := False;
      MessageDlg(msgErrorInternalBitmapFormat, mtError, [mbOk], 0);
      fOptionsChanged := False; //Opties niet bewaren bij interne bitmapfout
      Close;
    end;
  end;



  {$IFNDEF HUGE_WORLD}
  WX := fCellX * fLifeX + 1; //+1 voor gridlijntjes
  WY := fCellY * fLifeY + 1;
  {$ELSE}
  WX := fCellX * fLifeX;//In HUGE_WORLD geen Gridlines nodig
  WY := fCellY * fLifeY;
  {$ENDIF}

  ClientWidth := WX;
  ClientHeight := WY + StatusBar.Height+1;
  World.Width := WX;
  World.Height := WY;

  ChalkBoard.Width := WX;
  ChalkBoard.Height := WY;
  ChalkBoard.PixelFormat := pf24bit;

  //Hou Form gecentreerd (als dat gaat)
  WL := (Screen.Width - Width) div 2;
  WT := (Screen.Height - Height) div 2;
  if WL < 0 then WL := 0;
  if WT < 0 then WT := 0;

  SetBounds(WL, WT, Width, Height);
  DrawBackGround;
  {$IFNDEF HUGE_WORLD}
  //In HUGE_WORLD geen Gridlines nodig
  DrawGridLines;
  {$ENDIF}
  CopyChalkBoardToTheWorld;
//  World.Canvas.Draw(0,0,ChalkBoard);
end;

procedure TLifeForm.CopyChalkBoardToTheWorld;
begin
  World.Canvas.Draw(0,0,ChalkBoard);
end;


(*
function IsPointerToCell(const P: Pointer): Boolean;
var x,y: integer;
//Debug routine voor MakeConections
begin
  Result := false;
  for x := 0 to MaxLifeX-1 do for y := 0 to MaxLifeY-1 do
  begin
    if (p = @lifeform.generation[x,y]) or (p=nil) or (p=@lifeform.fNilCell) then
    begin
      Result := true;
//      form1.memo1.lines.add(format('%p [%d,%d]',[p,x,y]));
      exit;
    end;
  end;
end;
*)

procedure TLifeForm.MakeConnections(const UpdateBordersOnly: Boolean);
var X, Y: Integer;
begin
  {$R+}
  // Dit is nogal complex en lang, maar we doen dit alleen
  // 1. bij begin van het programma
  // 2. als de wrapstyle verandert (en dan alleen de randen)
  // 3. als de wereld van grootte verandert

  //Eerst boven en onderranden van de wereld
  for X := 0 to fLifeX - 1 do
  begin
    case fWrapStyle of
      wrNone:
      begin
        Generation[X,0].TopLeft     := @fNilCell;
        Generation[X,0].TopMid      := @fNilCell;
        Generation[X,0].TopRight    := @fNilCell;
        if (X<>0) then Generation[X,0].Left := @Generation[X-1,0] else Generation[X,0].Left := @fNilCell;
        if (X<>fLifeX-1) then Generation[X,0].Right := @Generation[X+1,0] else Generation[X,0].Right := @fNilCell;
        if (X<>0) then Generation[X,0].BottomLeft  := @Generation[X-1,1] else Generation[X,0].BottomLeft  := @fNilCell;
        Generation[X,0].BottomMid   := @Generation[X,1];
        if (X<>fLifeX-1) then Generation[X,0].BottomRight := @Generation[X+1,1] else Generation[X,0].BottomRight := @fNilCell;
        if (X<>0) then Generation[X,fLifeY-1].TopLeft := @Generation[X-1,fLifeY-2] else Generation[X,fLifeY-1].TopLeft := @fNilCell;
        Generation[X,fLifeY-1].TopMid := @Generation[X,fLifeY-2];
        if (X<>fLifeX-1) then Generation[X,fLifeY-1].TopRight := @Generation[X+1,fLifeY-2] else Generation[X,fLifeY-1].TopRight := @fNilCell;
        if (X<>0) then Generation[X,fLifeY-1].Left := @Generation[X-1,fLifeY-1] else Generation[X,fLifeY-1].Left := @fNilCell;
        if (X<>fLifeX-1) then Generation[X,fLifeY-1].Right := @Generation[X+1,fLifeY-1] else Generation[X,fLifeY-1].Right := @fNilCell;
        Generation[X,fLifeY-1].BottomLeft  := @fNilCell;
        Generation[X,fLifeY-1].BottomMid   := @fNilCell;
        Generation[X,fLifeY-1].BottomRight := @fNilCell;
      end;
      wrHorizontal:
      begin
        Generation[X,0].TopLeft     := @fNilCell;
        Generation[X,0].TopMid      := @fNilCell;
        Generation[X,0].TopRight    := @fNilCell;
        if (X=0) then Generation[X,0].Left := @Generation[fLifeX-1,0] else Generation[X,0].Left := @Generation[X-1,0];
        if (x=fLifeX-1) then Generation[X,0].Right := @Generation[0,0] else Generation[X,0].Right := @Generation[X+1,0];
        if (X=0) then Generation[X,0].BottomLeft  := @Generation[fLifeX-1,1] else Generation[X,0].BottomLeft  := @Generation[X-1,1];
        Generation[X,0].BottomMid   := @Generation[X,1];
        if (X=fLifeX-1) then Generation[X,0].BottomRight := @Generation[0,1] else Generation[X,0].BottomRight := @Generation[X+1,1];
        if (X=0) then Generation[X,fLifeY-1].TopLeft := @Generation[fLifeX-1,fLifeY-2] else Generation[X,fLifeY-1].TopLeft := @Generation[X-1,fLifeY-2];
        Generation[X,fLifeY-1].TopMid      := @Generation[X,fLifeY-2];
        if (X=fLifeX-1) then Generation[X,fLifeY-1].TopRight := @Generation[0,fLifeY-2] else Generation[X,fLifeY-1].TopRight := @Generation[X+1,fLifeY-2];
        if (X=0) then Generation[X,fLifeY-1].Left := @Generation[fLifeX-1,fLifeY-1] else Generation[X,fLifeY-1].Left := @Generation[X-1,fLifeY-1];
        if (X=fLifeX-1) then Generation[X,fLifeY-1].Right := @Generation[0,fLifeY-1] else Generation[X,fLifeY-1].Right := @Generation[X+1,fLifeY-1];
        Generation[X,fLifeY-1].BottomLeft  := @fNilCell;
        Generation[X,fLifeY-1].BottomMid   := @fNilCell;
        Generation[X,fLifeY-1].BottomRight := @fNilCell;
      end;
      wrVertical:
      begin
        if (X<>0) then Generation[X,0].TopLeft := @Generation[X-1,fLifeY-1] else Generation[X,0].TopLeft := @fNilCell;
        Generation[X,0].TopMid  := @Generation[X,fLifeY-1];
        if (X<>fLifeX-1) then Generation[X,0].TopRight := @Generation[X+1,fLifeY-1] else Generation[X,0].TopRight := @fNilCell;
        if (X<>0) then Generation[X,0].Left := @Generation[X-1,0] else Generation[X,0].Left := @fNilCell;
        if (X<>fLifeX-1) then Generation[X,0].Right := @Generation[X+1,0] else Generation[X,0].Right := @fNilCell;
        if (X<>0) then Generation[X,0].BottomLeft := @Generation[X-1,1] else Generation[X,0].BottomLeft := @fNilCell;
        Generation[X,0].BottomMid := @Generation[X,1];
        if (X<>fLifeX-1) then Generation[X,0].BottomRight := @Generation[X+1,1] else Generation[X,0].BottomRight := @fNilCell;
        if (X<>0) then Generation[X,fLifeY-1].TopLeft := @Generation[X-1,fLifeY-2] else Generation[X,fLifeY-1].TopLeft := @fNilCell;
        Generation[X,fLifeY-1].TopMid := @Generation[X,fLifeY-2];
        if (X<>fLifeX-1) then Generation[X,fLifeY-1].TopRight := @Generation[X+1,fLifeY-2] else Generation[X,fLifeY-1].TopRight := @fNilCell;
        if (X<>0) then Generation[X,fLifeY-1].Left := @Generation[X-1,fLifeY-1] else Generation[X,fLifeY-1].Left := @fNilCell;
        if (X<>fLifeX-1) then Generation[X,fLifeY-1].Right := @Generation[X+1,fLifeY-1] else Generation[X,fLifeY-1].Right := @fNilCell;
        if (X<>0) then Generation[X,fLifeY-1].BottomLeft := @Generation[X-1,0] else Generation[X,fLifeY-1].BottomLeft := @fNilCell;
        Generation[X,fLifeY-1].BottomMid := @Generation[X,0];
        if (X<>fLifeX-1) then Generation[X,fLifeY-1].BottomRight := @Generation[X+1,0] else Generation[X,fLifeY-1].BottomRight := @fNilCell;
      end;
      wrBoth:
      begin
        if (X<>0) then Generation[X,0].TopLeft := @Generation[X-1,fLifeY-1] else Generation[X,0].TopLeft := @Generation[fLifeX-1,fLifeY-1];
        Generation[X,0].TopMid := @Generation[X,fLifeY-1];
        if (X<>fLifeX-1) then Generation[X,0].TopRight := @Generation[X+1,fLifeY-1] else Generation[X,0].TopRight := @Generation[0,fLifeY-1];
        if (X<>0) then Generation[X,0].Left := @Generation[X-1,0] else Generation[X,0].Left := @Generation[fLifeX-1,0];
        if (X<>fLifeX-1) then Generation[X,0].Right := @Generation[X+1,0] else Generation[X,0].Right := @Generation[0,0];
        if (X<>0) then Generation[X,0].BottomLeft := @Generation[X-1,1] else Generation[X,0].BottomLeft := @Generation[fLifeX-1,1];
        Generation[X,0].BottomMid := @Generation[X,1];
        if (X<>fLifeX-1) then Generation[X,0].BottomRight := @Generation[X+1,1] else Generation[X,0].BottomRight := @Generation[0,1];
        if (X<>0) then Generation[X,fLifeY-1].TopLeft := @Generation[X-1,fLifeY-2] else Generation[X,fLifeY-1].TopLeft := @Generation[fLifeX-1,fLifeY-2];
        Generation[X,fLifeY-1].TopMid := @Generation[X,fLifeY-2];
        if (X<>fLifeX-1) then Generation[X,fLifeY-1].TopRight := @Generation[X+1,fLifeY-2] else Generation[X,fLifeY-1].TopRight := @Generation[0,fLifeY-2];
        if (X<>0) then Generation[X,fLifeY-1].Left := @Generation[X-1,fLifeY-1] else Generation[X,fLifeY-1].Left := @Generation[fLifeX-1,fLifeY-1];
        if (X<>fLifeX-1) then Generation[X,fLifeY-1].Right := @Generation[X+1,fLifeY-1] else Generation[X,fLifeY-1].Right := @Generation[0,fLifeY-1];
        if (X<>0) then Generation[X,fLifeY-1].BottomLeft := @Generation[X-1,0] else Generation[X,fLifeY-1].BottomLeft := @Generation[0,0];
        Generation[X,fLifeY-1].BottomMid := @Generation[X,0];
        if (X<>fLifeX-1) then Generation[X,fLifeY-1].BottomRight := @Generation[X+1,0] else Generation[X,fLifeY-1].BottomRight := @Generation[fLifeX-1,0];
      end;
    end;//case
  end;//for

  //Dan linker en rechter randen van de wereld
  for Y := 1 to fLifeY - 2 do
  begin
    case fWrapStyle of
      wrNone:
      begin
        Generation[0,Y].TopLeft := @fNilCell;
        Generation[0,Y].TopMid := @Generation[0,Y-1];
        Generation[0,Y].TopRight := @Generation[1,Y-1];
        Generation[0,Y].Left := @fNilCell;
        Generation[0,Y].Right := @Generation[1,Y];
        Generation[0,Y].BottomLeft := @fNilCell;
        Generation[0,Y].BottomMid := @Generation[0,Y+1];
        Generation[0,Y].BottomRight := @Generation[1,Y+1];
        Generation[fLifeX-1,Y].TopLeft := @Generation[fLifeX-2,Y-1];
        Generation[fLifeX-1,Y].TopMid := @Generation[fLifeX-1,Y-1];
        Generation[fLifeX-1,Y].TopRight := @fNilCell;
        Generation[fLifeX-1,Y].Left := @Generation[fLifeX-2,Y];
        Generation[fLifeX-1,Y].Right := @fNilcell;
        Generation[fLifeX-1,Y].BottomLeft := @Generation[fLifeX-2,Y+1];
        Generation[fLifeX-1,Y].BottomMid := @Generation[fLifeX-1,Y+1];
        Generation[fLifeX-1,Y].BottomRight := @fNilCell;
      end;
      wrHorizontal, wrBoth:
      begin
        Generation[0,Y].TopLeft := @Generation[fLifeX-1,Y-1];
        Generation[0,Y].TopMid := @Generation[0,Y-1];
        Generation[0,Y].TopRight := @Generation[1,Y-1];
        Generation[0,Y].Left := @Generation[fLifeX-1,Y];
        Generation[0,Y].Right := @Generation[1,Y];
        Generation[0,Y].BottomLeft := @Generation[fLifeX-1,Y+1];
        Generation[0,Y].BottomMid := @Generation[0,Y+1];
        Generation[0,Y].BottomRight := @Generation[1,Y+1];
        Generation[fLifeX-1,Y].TopLeft := @Generation[fLifeX-2,Y-1];
        Generation[fLifeX-1,Y].TopMid := @Generation[fLifeX-1,Y-1];
        Generation[fLifeX-1,Y].TopRight := @Generation[0,Y-1];
        Generation[fLifeX-1,Y].Left := @Generation[fLifeX-2,Y];
        Generation[fLifeX-1,Y].Right := @Generation[0,Y];
        Generation[fLifeX-1,Y].BottomLeft := @Generation[fLifeX-2,Y+1];
        Generation[fLifeX-1,Y].BottomMid := @Generation[fLifeX-1,Y+1];
        Generation[fLifeX-1,Y].BottomRight := @Generation[0,Y+1];
      end;
      wrVertical:
      begin
        Generation[0,Y].TopLeft := @fNilCell;
        Generation[0,Y].TopMid := @Generation[0,Y-1];
        Generation[0,Y].TopRight := @Generation[1,Y-1];
        Generation[0,Y].Left := @fNilCell;
        Generation[0,Y].Right := @Generation[1,Y];
        Generation[0,Y].BottomLeft := @fNilCell;
        Generation[0,Y].BottomMid := @Generation[0,Y+1];
        Generation[0,Y].BottomRight := @Generation[1,Y+1];
        Generation[fLifeX-1,Y].TopLeft := @Generation[fLifeX-2,Y-1];
        Generation[fLifeX-1,Y].TopMid := @Generation[fLifeX-1,Y-1];
        Generation[fLifeX-1,Y].TopRight := @fNilCell;
        Generation[fLifeX-1,Y].Left := @Generation[fLifeX-2,Y];
        Generation[fLifeX-1,Y].Right := @fNilCell;
        Generation[fLifeX-1,Y].BottomLeft := @Generation[fLifeX-2,Y+1];
        Generation[fLifeX-1,Y].BottomMid := @Generation[fLifeX-1,Y+1];
        Generation[fLifeX-1,Y].BottomRight := @fNilCell;
      end;
    end;//case
  end;//for

  //Ten slotte alles wat niet aan de rand van de wereld ligt
  if not UpdateBordersOnly then
  begin
    for X := 1 to fLifeX - 2 do for Y := 1 to fLifeY - 2 do
    begin
      Generation[X,Y].TopLeft     := @Generation[X-1,Y-1];
      Generation[X,Y].TopMid      := @Generation[X  ,Y-1];
      Generation[X,Y].TopRight    := @Generation[X+1,Y-1];
      Generation[X,Y].Left        := @Generation[X-1,Y  ];
      Generation[X,Y].Right       := @Generation[X+1,Y  ];
      Generation[X,Y].BottomLeft  := @Generation[X-1,Y+1];
      Generation[X,Y].BottomMid   := @Generation[X  ,Y+1];
      Generation[X,Y].BottomRight := @Generation[X+1,Y+1];
    end;
  end;

(*
//Debugging MakeConections: verwijzen alle pointers naar geldige cell?
memo1.Lines.BeginUpdate;
  for x := 0 to MaxLifeX-1 do for y := 0 to MaxLifeY-1 do
  begin
    if not IsPointerToCell(Generation[X,Y].TopLeft) then begin showmessage('Fout: ['+IntToStr(x)+','+IntToStr(y)+'].TopLeft'); exit; end;
    if not IsPointerToCell(Generation[X,Y].TopMid) then begin showmessage('Fout: ['+IntToStr(x)+','+IntToStr(y)+'].TopMid'); exit; end;
    if not IsPointerToCell(Generation[X,Y].TopRight) then begin showmessage('Fout: ['+IntToStr(x)+','+IntToStr(y)+'].TopRight'); exit; end;
    if not IsPointerToCell(Generation[X,Y].Left) then begin showmessage('Fout: ['+IntToStr(x)+','+IntToStr(y)+'].Left'); exit; end;
    if not IsPointerToCell(Generation[X,Y].Right) then begin showmessage('Fout: ['+IntToStr(x)+','+IntToStr(y)+'].Right'); exit; end;
    if not IsPointerToCell(Generation[X,Y].BottomLeft) then begin showmessage('Fout: ['+IntToStr(x)+','+IntToStr(y)+'].BottomLeft'); exit; end;
    if not IsPointerToCell(Generation[X,Y].BottomMid) then begin showmessage('Fout: ['+IntToStr(x)+','+IntToStr(y)+'].BottomMid'); exit; end;
    if not IsPointerToCell(Generation[X,Y].BottomRight) then begin showmessage('Fout: ['+IntToStr(x)+','+IntToStr(y)+'].BottomRight'); exit; end;
  end;
memo1.lines.EndUpdate;
ShowMessage('Alle connecties OK');
*)
end;

procedure TLifeForm.SetWrapStyle(Value: Integer);
begin
  if (Value <> fWrapStyle) and (Value in [wrNone, wrHorizontal, wrVertical, wrBoth]) then
  begin
    fWrapStyle := Value;
    MakeConnections(True);
  end;
end;

procedure TLifeForm.ResizeTheWorld(const NewLifeX, NewLifeY, NewCellX, NewcellY: Integer);
var X,Y: Integer;
    ChangeDimensions, ChangeCellSizes: Boolean;
begin
  ChangeDimensions := (fLifeX <> NewLifeX) or (fLifeY <> NewLifeY);
  ChangeCellSizes := (fCellX <> NewCellX) or (fCellY <> NewcellY);
  if not (ChangeDimensions or ChangeCellSizes) then Exit;
  fRunning := False;
  WorldTimer.Enabled := False;
  //Maak alle cellen buiten de oude grenzen dood
  if ChangeDimensions then
  begin
    for X := 0 to MaxLifeX - 1 do for Y := 0 to MaxLifeY - 1 do
    begin
      if (X > fLifeX - 1) or (Y > fLifeY - 1) then
      begin
        Generation[X,Y].Status := Dead;
        Generation[X,Y].PrevStatus := Dead;
      end;
    end;
    fLifeX := NewLifeX;
    fLifeY := NewLifeY;
    MakeConnections(False);
  end;//ChangeDimensions
  if ChangeCellSizes then
  begin
    fCellX := NewCellX;
    fCellY := NewCellY;
  end;
  Try
    Screen.Cursor := crHourGlass;
    StatusBar.Panels[1].Text := Format(msgEmptying,[fLifeX,fLifeY]);
    DrawEmptyWorld;
    DrawGeneration(True); //Teken alle cellen opnieuw, onafhankelijk van hun vorige status
  Finally
    Screen.Cursor := crDefault;
    StatusBar.Panels[1].Text := '';
  end;
  if ChangeDimensions then
  begin
    //Maak alle cellen buiten de nieuwe grenzen dood
    for X := 0 to MaxLifeX - 1 do for Y := 0 to MaxLifeY - 1 do
    begin
      if (X > fLifeX - 1) or (Y > fLifeY - 1) then
      begin
        Generation[X,Y].Status := Dead;
        Generation[X,Y].PrevStatus := Dead;
      end;
    end;
  end;//ChangeDimensions
end;

procedure TLifeForm.DrawCell(X, Y: Integer; AColor: TColor; Direct: Boolean);
var ARect: Trect;
begin
  World.Canvas.Brush.Color := AColor;
  ChalkBoard.Canvas.Brush.Color := AColor;
  {$IFNDEF HUGE_WORLD}
  ARect.Left := X*fCellX+1;
  ARect.Top := Y*fCellY+1;
  ARect.Right := ARect.Left + fCellX-1;
  ARect.Bottom := ARect.Top + fCellY-1;
  if Direct then World.Canvas.FillRect(ARect);
  ChalkBoard.Canvas.FillRect(ARect);
  {$ELSE}
  //function SetPixel(DC: HDC; X, Y: Integer; Color: COLORREF): COLORREF; stdcall;
  ARect.Left := X*fCellX;
  ARect.Top := Y*fCellY;
  ARect.Right := ARect.Left + fCellX;
  ARect.Bottom := ARect.Top + fCellY;
  if Direct then World.Canvas.FillRect(ARect);  //World.Canvas.Pixels[X,Y] := AColor;
  ChalkBoard.Canvas.FillRect(ARect); //ChalkBoard.Canvas.Pixels[X,Y] := AColor;
  {$ENDIF}
end;



procedure TLifeForm.DrawGeneration(const ForceAllCells: Boolean);
var X, Y, CurrentStatus: Integer;
   {$IFNDEF HUGE_WORLD}
    TheColor: TColor;
    {$ELSE}
    TheRGBTriple, DeadRGBTriple, LifeRGBTriple: TRGBTriple;
    Row:  Array[0..MaxCellY-1] of pRGBTripleArray;
    R,K: Integer;
    {$ENDIF}
//t0,t1: longint;
begin
  {$IFDEF HUGE_WORLD}
  DeadRGBTriple := ColorToRGBTriple(clDead);
  LifeRGBTriple := ColorToRGBTriple(clLife);
  {$ENDIF}
  fNothingHasChanged := True;

//t0:=gettickcount;

  for Y := 0 to fLifeY - 1 do for X := 0 to fLifeX - 1 do
  begin
    CurrentStatus := Generation[X,Y].Status;
    {$IFDEF HUGE_WORLD}
    for R := 0 to fCellY - 1 do Row[R] := ChalkBoard.ScanLine[(Y*fCellY)+R];
    {$ENDIF}
    if ForceAllCells or (CurrentStatus <> Generation[X,Y].PrevStatus) then
    {$IFNDEF HUGE_WORLD}
    begin
      if CurrentStatus = Alive then TheColor := clLife else TheColor := clDead;
      fNothingHasChanged := False;
      DrawCell(X,Y,TheColor,False);
    end;
    {$ELSE}
    begin
      //if CurrentStatus = Alive then DrawCell(X,Y,clLife,False)else DrawCell(X,Y,clDead,False);
      if (CurrentStatus = Alive) then TheRGBTriple := LifeRGBTriple else TheRGBTriple := DeadRGBTriple;
      for R := 0 to fCellY - 1 do
      begin
        for K := 0 to fCellX - 1 do
        begin
          Row[R][(X*fCellX)+K] := TheRGBTriple;
        end;
      end;
      fNothingHasChanged := False;
    end;
    {$ENDIF}
  end;
//@@
//t1:=gettickcount;

  CopyChalkBoardToTheWorld;
  UpdateStatusBar;
//  Application.ProcessMessages;

//  statusbar.Panels[1].text := Format('Tijd nodig voor tekenen: %d ms',[t1-t0]);
end;

procedure TLifeForm.BackupGeneration;
var X,Y: Integer;
begin
  for X := 0 to fLifeX - 1 do for Y := 0 to fLifeY - 1 do Generation[X,Y].PrevStatus := Generation[X,Y].Status;
end;

function TLifeForm.Neighbours(const X, Y: Integer): Integer;
var NB: Integer;
begin
  //Let op: Neighbours pas aanroepen na BackupGeneration!!!
  NB := Generation[X,Y].TopLeft^.PrevStatus +
        Generation[X,Y].TopMid^.PrevStatus +
        Generation[X,Y].TopRight^.PrevStatus +
        Generation[X,Y].Left^.PrevStatus +
        Generation[X,Y].Right^.PrevStatus +
        Generation[X,Y].BottomLeft^.PrevStatus +
        Generation[X,Y].BottomMid^.PrevStatus +
        Generation[X,Y].BottomRight^.PrevStatus;
  Result := NB;
end;


procedure TLifeForm.CalcNextGeneration;
var X, Y, NB: Integer;
begin
  BackupGeneration;
(*
Rules:
  An occupied cell dies if it has 0,1,4..8 neighbours.
  An occupied cell survives if it has 2 or 3 neighbours.
  An unoccupied cell becomes occupied if it has 3 neighnours.
*)
  for X := 0 to fLifeX - 1 do for Y := 0 to fLifeY - 1 do
  begin
    NB := Neighbours(X,Y);
    if Generation[X,Y].PrevStatus = Alive then
    begin//Cell is alive
      if (NB in [2,3]) then Generation[X,Y].Status := Alive else Generation[X,Y].Status := Dead;
    end
    else
    begin//Cell is dead
      if (NB = 3) then Generation[X,Y].Status := Alive else Generation[X,Y].Status := Dead;
    end;
  end;
  Inc(fGenerationCount);
end;

procedure TLifeForm.DoNextGeneration;
begin
  CalcNextGeneration;
  DrawGeneration(False);
end;


procedure TLifeForm.RunTheWorld;
begin
  if not fTimerRequestHandled then Exit;
  fTimerRequestHandled := False;
  fRunning := True;
  DoNextGeneration;

  if fNothingHasChanged then
  begin
    WorldTimer.Enabled := False;
    fRunning := False;
    ShowMessage('Stabiel systeem!');
  end;
  fTimerRequestHandled := True;
end;





procedure TLifeForm.UpdateStatusBar;
begin
  StatusBar.Panels[0].Text := Format('Generatie: %d',[fGenerationCount]);
  StatusBar.Panels[1].Text := '';
end;




procedure TLifeForm.UpdateMenu;
begin
  if fRunning then
  begin
    MenuStartGame.Caption       := '&Stop spel';
    MenuOneStep.Enabled         := False;
    MenuMoveLeft.Enabled        := False;
    MenuMoveRight.Enabled       := False;
    MenuMoveUp.Enabled          := False;
    MenuMoveDown.Enabled        := False;
    MenuMoveLeftLarge.Enabled   := False;
    MenuMoveRightLarge.Enabled  := False;
    MenuMoveUpLarge.Enabled     := False;
    MenuMoveDownLarge.Enabled   := False;
    MenuFlipHorizontal.Enabled  := False;
    MenuFlipVertical.Enabled    := False;
    MenuRotateLeft.Enabled      := False;
    MenuRotateRight.Enabled     := False;
    MenuRotate180.Enabled       := False;
    MenuInstructions.Enabled    := False;
    MenuAbout.Enabled           := False;
  end
  else
  begin
    MenuStartGame.Caption       := '&Start spel';
    MenuOneStep.Enabled         := True;
    MenuOneStep.Enabled         := True;
    MenuMoveLeft.Enabled        := True;
    MenuMoveRight.Enabled       := True;
    MenuMoveUp.Enabled          := True;
    MenuMoveDown.Enabled        := True;
    MenuMoveLeftLarge.Enabled   := True;
    MenuMoveRightLarge.Enabled  := True;
    MenuMoveUpLarge.Enabled     := True;
    MenuMoveDownLarge.Enabled   := True;
    MenuFlipHorizontal.Enabled  := True;
    MenuFlipVertical.Enabled    := True;
    MenuRotateLeft.Enabled      := True;
    MenuRotateRight.Enabled     := True;
    MenuRotate180.Enabled       := True;
    MenuInstructions.Enabled    := True;
    MenuAbout.Enabled           := True;
  end;
end;


procedure TLifeForm.KillAllCells;
var X,Y: Integer;
begin
  for X := 0 to fLifeX - 1 do for Y := 0 to fLifeY - 1 do
  begin
    Generation[X,Y].Status := Dead;
    Generation[X,Y].PrevStatus := Dead;
  end;
end;


procedure TLifeForm.TrimLifeLines(SL: TStringList);
var Count, p, FirstX, LastX, FirstY, LastY: Integer;
begin
//showmessage(sl.text);
  FirstX := fLifeX - 1;
  LastX := 1;//Ik wil minimaal 1 teken in een string
  FirstY := SL.Count;
  LastY := 0;
  //Verwijder evt. eerste commentaar regel
  if (SL.Count > 0) and (Length(SL.Strings[0]) > 0) and (SL.Strings[0][1] in CommentChars) then SL.Delete(0);
//showmessage(sl.text);
  for Count := 0 to SL.Count - 1 do
  begin
    for p := 1 to Length(SL.Strings[Count]) do
    begin
      if (SL.Strings[Count][p] in LifeChars) then
      begin
        if (p < FirstX) then FirstX := p;
        if (p > LastX) then LastX := p;
        if (Count < FirstY) then FirstY := Count;
        if (Count > LastY) then LastY := Count;
      end;
    end;
  end;
  for Count := 0 to LastY do
  begin
    if (Length(SL.Strings[Count]) > LastX) then SL.Strings[Count] := Copy(SL.Strings[Count], 1, LastX);
    if (FirstX > 1) and (Length(SL.Strings[Count]) > FirstX) then SL.Strings[Count] := Copy(SL.Strings[Count], FirstX, Length(SL.Strings[Count]) - (FirstX - 1));
  end;
//showmessage(sl.text);
  //Laatste regels met alleen dode cellen verwijderen
  for Count := SL.Count - 1 downto LastY + 1 do SL.Delete(Count);
//showmessage(sl.text);
  //Eerste regels met alleen dode cellen (of 1e commentaarrregel) verwijderen
  for Count := 0 to FirstY-1 do if (SL.Count > 0) then SL.Delete(0);
//showmessage(sl.text);
end;


procedure TLifeForm.NewGame;
//var T0,T1: longint;
begin
  fRunning := False;
  WorldTimer.Enabled := False;
  KillAllCells;
  fGenerationCount := 0;
  try
    StatusBar.Panels[1].Text := Format(msgEmptying,[fLifeX, fLifeY]);
    Application.ProcessMessages;
    Screen.Cursor := crHourGlass;
//t0:=gettickcount;
    DrawGeneration(True);
//t1:=gettickcount;
    StatusBar.Panels[1].Text := '';
//StatusBar.Panels[1].Text := Format('Tijdsduur: %d',[t1-t0]);
    Application.ProcessMessages;
  finally
    Screen.Cursor := crDefault;
  end;
end;

{function Min(const L1, L2: LongInt): LongInt;
begin
  if L1 < L2 then Result := L1 else Result := L2;
end;}


procedure TLifeForm.OpenGame;
var Lines: TStringList;
    Fn: String;
    i, p: Integer;
begin
  {$R+}
  fRunning := False;
  WorldTimer.Enabled := False;
  if OpenDialog.Execute then
  begin//if OpenDialog
    //Even dialoogvenster opruimen, anders valt er een "gat" in World
    Application.ProcessMessages;
    KillAllCells;
    fGenerationCount := 0;
    Fn := OpenDialog.FileName;
    Lines := TStringList.Create;
    try
      try
        Screen.Cursor := crHourGlass;
        Lines.LoadFromFile(Fn);
        AdjustLineBreaks(Lines.Text);
        TrimLifeLines(Lines);
        for i := 0 to IntMin(Lines.Count - 1, fLifeY - 1) do
        begin//verwerk regels
          for p := 1 to IntMin(fLifeX , Length(Lines[i])) do
          if (Length(Lines[i]) > 0) and not ((i = 0) and (Lines[i][1] in CommentChars)) then
          begin//Regel is geen commentaar regel
            begin//verwerk iedere char
              if Lines[i][p] in LifeChars then
              begin//deze cell leeft
                Generation[p-1,i].Status := Alive;
                Generation[p-1,i].PrevStatus := Alive;
              end;
            end;
          end;
        end;//verwerk alle regels
        StatusBar.Panels[1].Text := Format(msgDrawing,[fLifeX, fLifeY]);
        Application.ProcessMessages;
        DrawGeneration(True);
      except
        on E: EStreamError do MessageDlg(Format(msgErrorFileOpen,[Fn]),mtError,[mbOk],0)
      end;
    finally
       StatusBar.Panels[1].Text := '';
       Screen.Cursor := crDefault;
       Application.ProcessMessages;
       Lines.Free;
    end;
  end;//if OpenDialog
end;

procedure TLifeForm.SaveGame;
var Lines: TStringList;
    Fn: String;
    X, Y: Integer;
    S, CommentString: String;
begin
  {$R+}
  fRunning := False;
  WorldTimer.Enabled := False;
  if SaveDialog.Execute then
  begin
    Fn := SaveDialog.FileName;
    CommentString := ExtractFileName(Fn);
    CommentString := ChangeFileExt(CommentString,'');
    CommentString := '!Naam:'+CommentString+'!';
    Lines := TStringList.Create;
    try
      Screen.Cursor := crHourGlass;
      StatusBar.Panels[1].Text := Format(msgProcessing,[fLifeX,fLifeY]);
      Application.ProcessMessages;
      try
        for Y := 0 to fLifeY - 1 do
        begin//"Regel" voor "regel"
          S := StringOfChar(DeadChar,fLifeX);
          for X := 0 to fLifeX - 1 do
          begin//Cell voor cell
            if Generation[X,Y].Status = Alive then S[X+1] := LifeChar;
          end;
          Lines.Add(S);
        end;//"Regel" voor "regel"
        TrimLifeLines(Lines);
        Lines.Insert(0,CommentString);
        Lines.SaveToFile(Fn);
      except
        on E: EStreamError do MessageDlg(Format(msgErrorFileSave,[Fn, NlErrorMsg(GetLastError)]),mtError,[mbOk],0)
      end;
    finally
      Screen.Cursor := crDefault;
      StatusBar.Panels[1].Text := '';
      Application.ProcessMessages;
      Lines.Free;
    end;
  end;//if SaveDialog
end;


procedure TLifeForm.MoveLeft(const ADistance: Integer);
var X, Y: Integer;
begin
  BackupGeneration;
  for X := 0 to fLifeX - 1 do for Y := 0 to fLifeY - 1 do
  begin
    //if X = fLifeX - 1 then Generation[X,Y].Status := Dead else Generation[X,Y].Status := Generation[X,Y].Right^.PrevStatus;
    if (X + Adistance) > (fLifeX - 1) then Generation[X,Y].Status := Dead else Generation[X,Y].Status := Generation[X + ADistance,Y].PrevStatus;
  end;
  DrawGeneration(False);
end;

procedure TLifeForm.MoveRight(const ADistance: Integer);
var X, Y: Integer;
begin
  BackupGeneration;
  for X := 0 to fLifeX - 1 do for Y := 0 to fLifeY - 1 do
  begin
    //if X = 0 then Generation[X,Y].Status := Dead else Generation[X,Y].Status := Generation[X,Y].Left^.PrevStatus;
    if (X - ADistance) < 0 then Generation[X,Y].Status := Dead else Generation[X,Y].Status := Generation[X-ADistance,Y].PrevStatus;
  end;
  DrawGeneration(False);
end;

procedure TLifeForm.MoveUp(const ADistance: Integer);
var X, Y: Integer;
begin
  BackupGeneration;
  for X := 0 to fLifeX - 1 do for Y := 0 to fLifeY - 1 do
  begin
    //if Y = fLifeY - 1 then Generation[X,Y].Status := Dead else Generation[X,Y].Status := Generation[X,Y].BottomMid^.PrevStatus;
    if (Y + ADistance) > (fLifeY - 1) then Generation[X,Y].Status := Dead else Generation[X,Y].Status := Generation[X,Y + ADistance].PrevStatus;
  end;
  DrawGeneration(False);
end;

procedure TLifeForm.MoveDown(const ADistance: Integer);
var X, Y: Integer;
begin
  BackupGeneration;
  for X := 0 to fLifeX - 1 do for Y := 0 to fLifeY - 1 do
  begin
    //if Y = 0 then Generation[X,Y].Status := Dead else Generation[X,Y].Status := Generation[X,Y].TopMid^.PrevStatus;
    if (Y - ADistance) < 0 then Generation[X,Y].Status := Dead else Generation[X,Y].Status := Generation[X,Y - ADistance].PrevStatus;
  end;
  DrawGeneration(False);
end;

procedure TLifeForm.FlipHorizontal;
var X, Y: Integer;
begin
  BackupGeneration;
  for X := 0 to (fLifeX - 1) div 2 do
  begin
    for Y := 0 to fLifeY - 1 do
    begin
      Generation[X,Y].Status := Generation[(fLifeX-1)-X,Y].PrevStatus;
      Generation[(fLifeX-1)-X,Y].Status := Generation[X,Y].PrevStatus;
    end;
  end;
  DrawGeneration(False);
end;

procedure TLifeForm.FlipVertical;
var X, Y: Integer;
begin
  BackupGeneration;
  for Y := 0 to (fLifeY - 1) div 2 do
  begin
    for X := 0 to fLifeX - 1 do
    begin
      Generation[X,Y].Status := Generation[X,(fLifeY-1)-Y].PrevStatus;
      Generation[X,(fLifeY-1)-Y].Status := Generation[X,Y].PrevStatus;
    end;
  end;
  DrawGeneration(False);
end;


(*
Cartesian rotate
X --> X*Cos(angle) - Y*Sin(angle)
Y --> Y*Cos(angle) + X*Sin(angle)
*)

(*
type
  TRotation = (Rt90, Rt180, Rt270);

procedure RotateBord(var ABord: TBord; const ARotation: TRotation);
var
  Mirror: TBord;
  X: Integer;
  Y: Integer;
begin
  Mirror := ABord;
  for X := 0 to MaxX do
    for Y := 0 to MaxY do
      case ARotation of
        rt90: ABord[Y, X] := Mirror[X, MaxY - Y];
        rt180: ABord[Y, X] := Mirror[MaxX - X, MaxY - Y];
        rt270: ABord[Y, X] := Mirror[MaxX - X, Y];
      end;
end;
*)

procedure TLifeForm.RotateLeft;
var X, Y, MaxXY: Integer;
begin
//exit;
  BackupGeneration;
  //Zoek grootst mogelijke vierkant
  MaxXY := IntMin(fLifeX, fLifeY);
  for X := 0 to MaxXY - 1 do
  begin
    for Y := 0 to MaxXY - 1 do
    begin
      Generation[Y,X].Status := Generation[(MaxXY-1)-X, Y].PrevStatus;
    end;
  end;
  //Maak alle cellen buiten rotatievierkant dood
  for X := 0 to fLifeX - 1 do for Y := 0 to fLifeY - 1 do
  begin
    if (X > MaxXY - 1) or (Y > MaxXY - 1) then
    begin
      Generation[X,Y].Status := Dead;
    end;
  end;
  DrawGeneration(False);
end;

procedure TLifeForm.RotateRight;
var X, Y, MaxXY: Integer;
begin
//exit;
  BackupGeneration;
  //Zoek grootst mogelijke vierkant
  MaxXY := IntMin(fLifeX, fLifeY);
  for X := 0 to MaxXY - 1 do
  begin
    for Y := 0 to MaxXY - 1 do
    begin
      Generation[Y,X].Status := Generation[X, (MaxXY-1)-Y].PrevStatus;
    end;
  end;
  //Maak alle cellen buiten rotatievierkant dood
  for X := 0 to fLifeX - 1 do for Y := 0 to fLifeY - 1 do
  begin
    if (X > MaxXY - 1) or (Y > MaxXY - 1) then
    begin
      Generation[X,Y].Status := Dead;
    end;
  end;
  DrawGeneration(False);
end;

procedure TLifeForm.Rotate180;
var X, Y: Integer;
begin
//exit;
  BackupGeneration;
  for X := 0 to fLifeX - 1 do
  begin
    for Y := 0 to fLifeY - 1 do
    begin
      //rt180: ABord[Y, X] := Mirror[MaxX - X, MaxY - Y];
      Generation[X,Y].Status := Generation[(fLifeX-1)-X, (fLifeY-1)-Y].PrevStatus;
    end;
  end;
  DrawGeneration(False);
end;

procedure TLifeForm.GameInstructions;
begin
  HelpForm.Show;
end;

procedure TLifeForm.AboutGame;
begin
  AboutDlgEx(AboutTitle, ProductName, Version, CopyRight, ProductURL,
             LicenceCaption, LicenseName, LicenseUrl, ProductComment);
end;




end.


(*



*)
